<template>
  <div>
    <div class="mt-4" v-if="dataLoaded">
      <gl-alert :dismissible="false" class="mb-3">
        Found {{ results.length }} results in {{ totalSelectors }} CSS selectors
        in our application.css which is the base for all analysis.
      </gl-alert>
      <b-form-input
        v-model="searchString"
        type="search"
        placeholder="Search ..."
        @input="doSearch"
        :autofocus="true"
      ></b-form-input>
      <gl-table v-if="results" :items="results" :fields="$options.fields">
        <template #cell(selector)="row">
          <strong>{{ row.item.selector }}</strong>
          <div>
            <code v-html="convertRuleString(row.item.rule)"></code>
          </div>
        </template>
        <template #cell(baseSelector)="{ item }">
          <span v-if="item.selector !== item.baseSelector">{{
            item.baseSelector
          }}</span>
        </template>
        <template #cell(file)="{ item }">
          <a
            :href="`https://gitlab.com/gitlab-org/gitlab/-/blob/master/${item.file}#L${item.filePosition}`"
            target="_blank"
            v-if="item.internalFile && item.file.indexOf('node_modules') === -1"
          >
            {{ item.file }}:{{ item.filePosition }}
          </a>
          <a
            :href="`https://gitlab.com/gitlab-org/gitlab-ui/-/tree/master/${item.file.replace(
              'node_modules/@gitlab/ui/',
              ''
            )}#L${item.filePosition}`"
            target="_blank"
            v-else-if="
              item.internalFile &&
              item.file.indexOf('node_modules/@gitlab/ui/') === 0
            "
          >
            {{ item.file }}:{{ item.filePosition }}
          </a>
          <span v-else>{{ item.file }}:{{ item.filePosition }}</span>
        </template>
      </gl-table>
    </div>
    <div class="mt-4" v-if="!dataLoaded">
      Loading ...
    </div>
  </div>
</template>

<script>
import axios from 'axios';
import _ from 'lodash';
import FlexSearch from 'flexsearch';
import { GlAlert, GlLink, GlTable } from '@gitlab/ui';

let searchIndex;

export default {
  components: {
    GlTable,
    GlAlert,
    GlLink,
  },
  fields: [
    {
      key: 'selector',
      label: 'Selector',
      sortable: true,
    },
    {
      key: 'rulesLength',
      label: 'Rules Length',
      sortable: true,
    },

    {
      key: 'selectorLength',
      label: 'Selector Length',
      sortable: true,
    },
    {
      key: 'file',
      label: 'File',
      sortable: true,
    },
  ],
  data() {
    return {
      searchString: this.$route.query.q,
      dataLoaded: false,
      totalSelectors: 0,
      results: [],
    };
  },
  mounted() {
    this.initSearch();
  },
  methods: {
    convertRuleString: function (val) {
      return val.replace(/,/gi, ';<br/>');
    },
    doSearch: _.debounce(function (newVal) {
      if (newVal && searchIndex) {
        this.results = searchIndex.search(newVal);
      } else {
        this.results = [];
      }
    }, 300),
    async initSearch() {
      // Lazy Window caching for the search index
      if (!window.searchIndex) {
        const { data } = await axios.get('css-map-all.json');
        this.totalSelectors = data.length;

        searchIndex = new FlexSearch({
          doc: {
            id: 'selector',
            field: ['selector', 'rule', 'file'],
          },
        });
        searchIndex.add(data);
        window.searchIndex = searchIndex;
        window.totalSelectors = this.totalSelectors;
      } else {
        searchIndex = window.searchIndex;
        this.totalSelectors = window.totalSelectors;
      }

      this.dataLoaded = true;

      if (this.searchString) {
        this.results = searchIndex.search(this.searchString);
      }
    },
  },
};
</script>
